module MysqlSlaver
  class Executor
    attr_reader :ssh_port, :dry_run

    include Logger

    def initialize(params = {})
      @ssh_port = params[:ssh_port]
      @dry_run  = params.fetch(:dry_run, false)
    end

    def ssh_command(cmd, host)
      if ssh_port
        "ssh -p #{ssh_port} #{host} '#{cmd}'"
      else
        "ssh #{host} '#{cmd}'"
      end
    end

    def execute(cmd)
      string = cmd.is_a?(Array) ? cmd.join('; ') : cmd
      log "CMD: #{string}"
      if dry_run
        "[DUMMY RESULT]"
      else
        result = `#{string}`
        success? ? result : nil
      end
    end

    private

    def success?
      $?.success?
    end
  end
end
